lappend auto_path [file normalize ..]

package require tokenentry
package require tokensearch
package require wmarkentry

set te2tokens  [list]
set ts1history [list]
  
proc create {} {

  set ::foobar ""

  # Create a token entry
  frame .f
  tokenentry::tokenentry   .f.te1 -tokenshape [list tag square] -relief sunken -watermark "Enter text" -xscrollcommand {.f.hb1 set}
  ttk::scrollbar           .f.hb1 -orient horizontal -command {.f.te1 xview}
  tokenentry::tokenentry   .f.te2 -tokenvar te2tokens -tokenshape eased -bg pink
  tokensearch::tokensearch .f.ts1 -categories [list {Categories {pill tag square}} {{Other Stuff} {eased ticket}}] -bg pink -historyvar ts1history
  ttk::scrollbar           .f.hb2 -orient horizontal -command {.f.ts1 xview}
  tokensearch::tokensearch .f.ts2 -categories   {{Properties {Name Kind Label Tag {Something Else}}}} \
                                  -categoryopts {{checkbutton {Ignore Case} 1} {radiobutton {{Use regexp} {Use exact}} {Use regexp}}} \
                                  -watermark "Search tokens"
  wmarkentry::wmarkentry   .f.wme -background white -relief ridge -watermark "Enter text here" -textvariable ::foobar
  ttk::button              .f.b -text "Tokens" -command {
    puts "te1: [.f.te1 tokenget]"
    puts "te2: [.f.te2 tokenget], te2tokens: $te2tokens"
    puts "ts1: [.f.ts1 tokenget]"
    puts "ts2: [.f.ts2 tokenget]"
    .f.te2 configure -state normal
    .f.te1 configure -watermark "Enter new text" -watermarkforeground "light blue"
  }
  ttk::button .f.b2 -text "Restart" -command {
    destroy .f
    create
  }

  bind .f.te1 <<TokenEntryModified>> {puts "te1 modified: [.f.te1 tokenget]"}
  bind .f.te2 <<TokenEntryModified>> {puts "te2 modified: [.f.te2 tokenget]"}
  bind .f.ts1 <<TokenSearchModified>> {
    puts "ts1 modified: [.f.ts1 tokenget]"
    set i 0
    foreach value [.f.ts1 tokenget] {
      .f.ts1 tokenconfigure $i -shape [lindex $value 0]
      incr i
    }
  }

  grid .f.te1 -row 0 -column 0 -sticky news -padx 2 -pady 2
  grid .f.b   -row 0 -column 1 -sticky news -padx 2 -pady 2
  grid .f.te2 -row 1 -column 0 -sticky news -padx 2 -pady 2
  grid .f.b2  -row 1 -column 1 -sticky news -padx 2 -pady 2
  grid .f.hb2 -row 2 -column 0 -sticky ew   -padx 2 -pady 2
  grid .f.ts1 -row 3 -column 0 -sticky news -padx 2 -pady 2
  grid .f.hb1 -row 4 -column 0 -sticky ew   -padx 2 -pady 2
  grid .f.ts2 -row 5 -column 0 -sticky news -padx 2 -pady 2
  grid .f.wme -row 6 -column 0 -sticky news -padx 2 -pady 2

  pack .f

  set ::values {{Trevor phase1geo@gmail.com} {Bubba bubba@hotmail.com} {{Joe Bob} jbob@yahoo.com}}

  .f.te1 configure -height 1 -width 20 -font [font create -size 6] -tokenbg "light green" -tokenbordercolor "dark green" -tokenselectbg "green" \
                   -listvar values -dropdownformatstring "%s  (%s)" -matchcase 1 -matchdisplayindex 1 -matchmode glob -wrap 0

  .f.te2 tokeninsert end [list foobar barfoo dude]
  # .f.te2 tokenconfigure 1 -bg yellow -fg "dark green" -bordercolor red -selectbg "dark green" -selectfg yellow -selectbordercolor pink
  .f.te2 tokeninsert 3 good
  .f.te2 configure -state disabled
  .f.ts1 tokeninsert end [list lorry something]

  puts "te1 configure: [.f.te1 configure]"
  puts "te1 configure -listvar: [.f.te1 configure -listvar]"
  
  .f.wme insert end "Some kind of string"
  .f.wme selection from 1
  .f.wme selection to 6
  .f.wme delete 0 end
  # puts "first: [.f.wme index sel.first], last: [.f.wme index sel.last]"
  # .f.wme delete 0 end
  # .f.wme selection clear

  focus .f.te2
  
}

ttk::style theme use clam

create
